unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  sSkinProvider, sSkinManager, sComboBoxes, ExtCtrls, sPanel, FileCtrl,
  sScrollBox, Unit2, ImgList, sStatusBar, sButtonControl, sCustomButton,
  sGauge, sCheckedControl, sCheckbox, sHintManager, ExtDlgs, Unit17;

type
  TMainForm = class(TForm)
    sSkinManager1: TsSkinManager;
    sSkinProvider1: TsSkinProvider;
    sToolBar1: TsToolBar;
    sComboBox1: TsComboBoxEx;
    ImageList16: TImageList;
    FrameDemo1: TFrameDemo;
    sBitBtn5: TsSpeedButton;
    sBitBtn2: TsSpeedButton;
    sBitBtn3: TsSpeedButton;
    sBitBtn1: TsSpeedButton;
    sStatusBar1: TsStatusBar;
    sGauge3: TsGauge;
    ImageList26: TImageList;
    sHintManager1: TsHintManager;
    sCheckBox4: TsCheckBox;
    sCheckBox18: TsCheckBox;
    OpenPictureDialog1: TOpenPictureDialog;
    FrameAbout1: TFrameAbout;
    procedure FormShow(Sender: TObject);
    procedure sComboBox1Change(Sender: TObject);
    procedure sBitBtn1Click(Sender: TObject);
    procedure FrameDemo1sBitBtn5Click(Sender: TObject);
    procedure FrameDemo1sBitBtn6Click(Sender: TObject);
    procedure FrameDemo1sBitBtn7Click(Sender: TObject);
    procedure FrameDemo1sBitBtn8Click(Sender: TObject);
    procedure FrameDemo1sBitBtn9Click(Sender: TObject);
    procedure FrameDemo1sBitBtn10Click(Sender: TObject);
    procedure FrameDemo1sBitBtn11Click(Sender: TObject);
    procedure FrameDemo1sBitBtn12Click(Sender: TObject);
    procedure sCheckBox4Change(Sender: TObject);
    procedure sHintManager1ShowHint(var HintStr: String;
      var CanShow: Boolean; var HintInfo: THintInfo);
    procedure sCheckBox18Change(Sender: TObject);
    procedure sBitBtn5Click(Sender: TObject);
    procedure sSkinManager1AfterChange(Sender: TObject);
    procedure OpenPictureDialog1SelectionChange(Sender: TObject);
    procedure sBitBtn3Click(Sender: TObject);
    procedure sBitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CurrentFrame : TFrame;
  end;

var
  MainForm: TMainForm;
  Loading : boolean;
  ChangedImage : string;

implementation

uses sMaskData, sStyleSimply, sSkinProps, ShellApi;

{$R *.DFM}

procedure TMainForm.FormShow(Sender: TObject);
var
  sl : TStringList;
  i : integer;
begin
  // Initialize path to skins directory
  // Symbols ".\" will be replaced automatically to path of programm startup
  sSkinManager1.SkinDirectory := '..\Skins';
  // Get first available skin name and fill items in combobox
  // To 'sSkinManager1.SkinName' will be copied name of the first available skin
  sl := TStringList.Create;
  sSkinManager1.SkinName := sSkinManager1.GetSkinNames(sl);
  sComboBox1.ItemsEx.Clear;
  sComboBox1.Items.Add('Skins directory...');
  sComboBox1.ItemsEx.Add;
  sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].Caption := 'Skins directory...';
  sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].ImageIndex := 0;
  for i := 0 to sl.Count - 1 do begin
    sComboBox1.Items.Add(sl[i]);
    sComboBox1.ItemsEx.Add;
    sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].Caption := sl[i];
    sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].ImageIndex := 3;
  end;
  // If no available skins...
  if sComboBox1.Items.Count < 1 then begin
    sComboBox1.Items.Add('No skins available');
    sComboBox1.ItemIndex := 0;
  end
  else begin
    // Sets ComboBox to current skin name value without skin changing
    Loading := True;
    sComboBox1.ItemIndex := sl.IndexOf(sSkinManager1.SkinName) + 1;
    Loading := False;
  end;
  FreeAndNil(sl);

  CurrentFrame := FrameAbout1;
  FrameDemo1.UpdateFrame;
end;

procedure TMainForm.sComboBox1Change(Sender: TObject);
var
  sl : TStringList;
  s : string;
  i : integer;
begin
  // Change skin
  if Loading then Exit;
  if sComboBox1.ItemIndex = 0 then begin
    if SelectDirectory(s, [], 0) then begin
      sSkinManager1.SkinDirectory := s;
      sl := TStringList.Create;
      sSkinManager1.SkinName := sSkinManager1.GetSkinNames(sl);
      sComboBox1.ItemsEx.Clear;
      sComboBox1.Items.Clear;
      sComboBox1.Items.Add('Skins directory...');
      sComboBox1.ItemsEx.Add;
      sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].Caption := 'Skins directory...';
      sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].ImageIndex := 0;
      for i := 0 to sl.Count - 1 do begin
        sComboBox1.Items.Add(sl[i]);
        sComboBox1.ItemsEx.Add;
        sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].Caption := sl[i];
        sComboBox1.ItemsEx[sComboBox1.ItemsEx.Count - 1].ImageIndex := 3;
      end;
      // If no available skins...
      FreeAndNil(sl);
    end;
  end
  else begin
    sSkinManager1.SkinName := sComboBox1.Text;
  end;
end;

procedure TMainForm.sBitBtn1Click(Sender: TObject);
begin
  Close
end;

procedure TMainForm.FrameDemo1sBitBtn5Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn5Click(Sender);

end;

procedure TMainForm.FrameDemo1sBitBtn6Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn6Click(Sender);

end;

procedure TMainForm.FrameDemo1sBitBtn7Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn7Click(Sender);

end;

procedure TMainForm.FrameDemo1sBitBtn8Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn8Click(Sender);

end;

procedure TMainForm.FrameDemo1sBitBtn9Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn9Click(Sender);

end;

procedure TMainForm.FrameDemo1sBitBtn10Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn10Click(Sender);

end;

procedure TMainForm.FrameDemo1sBitBtn11Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn11Click(Sender);

end;

procedure TMainForm.FrameDemo1sBitBtn12Click(Sender: TObject);
begin
  FrameDemo1.sBitBtn12Click(Sender);

end;

procedure TMainForm.sCheckBox4Change(Sender: TObject);
begin
  ShowHint := sCheckBox4.Checked;
end;

procedure TMainForm.sHintManager1ShowHint(var HintStr: String; var CanShow: Boolean; var HintInfo: THintInfo);
begin
  HintStr := HintInfo.HintControl.ClassName;
end;

procedure TMainForm.sCheckBox18Change(Sender: TObject);
var
  i, j : integer;
begin
  for i := 0 to ComponentCount - 1 do begin
    if (Components[i] is TControl) and (Components[i].Tag = 5)
      then TControl(Components[i]).Enabled := sCheckBox18.Checked
      else if (Components[i] is TFrame) then begin
        for j := 0 to TFrame(Components[i]).ComponentCount - 1 do begin
          if (TFrame(Components[i]).Components[j] is TControl) and (TFrame(Components[i]).Components[j].Tag = 5)
                then TControl(TFrame(Components[i]).Components[j]).Enabled := sCheckBox18.Checked
        end;
      end;
  end;
end;

procedure TMainForm.sBitBtn5Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute and (ChangedImage <> OpenPictureDialog1.FileName) then begin
    ChangedImage := OpenPictureDialog1.FileName;
    // SkinSections and PropNames are defined in sSkinProps.pas unit
    sSkinManager1.ChangeImageInSkin(NormalForm, PatternFile, OpenPictureDialog1.FileName);
    sSkinManager1.ChangeImageInSkin(NormalForm, HotPatternFile, OpenPictureDialog1.FileName);
    // Update of all controls
    sSkinManager1.UpdateSkin;
  end;
end;

procedure TMainForm.sSkinManager1AfterChange(Sender: TObject);
var
  i : integer;
begin
  i := GetSkinIndex(NormalForm);
  if IsValidSkinIndex(i) then begin
    sBitBtn5.Enabled := gd[i].ImagePercent > 0;
    ChangedImage := '';
    Loading := True;
    sComboBox1.ItemIndex := sComboBox1.Items.IndexOf(sSkinManager1.SkinName);
    Loading := False;
  end;
end;

procedure TMainForm.OpenPictureDialog1SelectionChange(Sender: TObject);
begin
  if ChangedImage = OpenPictureDialog1.FileName then Exit;
  if (pos('.BMP', UpperCase(OpenPictureDialog1.FileName)) > 0) or
       (pos('.JPG', UpperCase(OpenPictureDialog1.FileName)) > 0) or
         (pos('.BMP', UpperCase(OpenPictureDialog1.FileName)) > 0) then begin
    // SkinSections and PropNames are defined in sSkinProps.pas unit
    sSkinManager1.ChangeImageInSkin(NormalForm, PatternFile, OpenPictureDialog1.FileName);
    sSkinManager1.ChangeImageInSkin(NormalForm, HotPatternFile, OpenPictureDialog1.FileName);
    // Update of all controls
    sSkinManager1.UpdateSkin;
  end;
end;

procedure TMainForm.sBitBtn3Click(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', PChar('http://www.alphaskins.com/pchase.php'), nil, nil, SW_NORMAL);
end;

procedure TMainForm.sBitBtn2Click(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', PChar('http://www.alphaskins.com'), nil, nil, SW_NORMAL);
end;

end.
